import { Context } from 'react';
import { Container } from './container';
export interface Store<P extends unknown[] = unknown[], V = unknown> {
    (...args: P): V;
    displayName?: string;
    Context?: Context<Container<V>>;
}
export declare type StoreP<S extends Store> = S extends Store<infer P, any> ? P : never;
export declare type StoreV<S extends Store> = S extends Store<any, infer V> ? V : never;
export declare const defaultStoreValue: any;
export declare function getStoreContext<S extends Store>(s: S): Context<Container<unknown>>;
